dnl $Header: //guest/Jon_Parise/api/php/config.m4#8 $
dnl vim: expandtab

PHP_ARG_WITH(perforce, whether to enable Perforce client functions,
[  --with-perforce[=DIR]   Enable support for Perforce client functions])

if test "$PHP_PERFORCE" != "no"; then
  if test -r $PHP_PERFORCE/; then
     SEARCH_PATH=$PHP_PERFORCE
  else # search default path list
     SEARCH_PATH="/usr/local /usr"
  fi

  AC_MSG_CHECKING(for Perforce API files)
  SEARCH_FOR="/include/p4/clientapi.h"
  for i in $SEARCH_PATH ; do
    if test -r $i/$SEARCH_FOR; then
      P4API_DIR=$i
      AC_MSG_RESULT(found in $i)
    fi
  done

  if test -z "$P4API_DIR"; then
     AC_MSG_RESULT(not found)
     AC_MSG_ERROR(Please specify the path to the Perforce client API)
  fi

  AC_DEFINE(HAVE_PERFORCE,1,[ ])
  PHP_SUBST(PERFORCE_SHARED_LIBADD)
  PHP_ADD_LIBRARY_WITH_PATH("supp", $P4API_DIR/lib, PERFORCE_SHARED_LIBADD)
  PHP_ADD_LIBRARY_WITH_PATH("rpc", $P4API_DIR/lib, PERFORCE_SHARED_LIBADD)
  PHP_ADD_LIBRARY_WITH_PATH("client", $P4API_DIR/lib, PERFORCE_SHARED_LIBADD)
  PHP_ADD_INCLUDE($P4API_DIR/include/p4)
  PHP_NEW_EXTENSION(perforce, perforce.cpp, $ext_shared,,, yes)
  PHP_REQUIRE_CXX
fi
